(function ($) {
    $.fn.watchor = function (options) {
        var that = this;

        //重置状态
        var reset = function(elm){
            $(elm).data("__OriginalVal", $(elm).val());
            if($(elm).is(":radio,:checkbox")){
                $(elm).data("__OriginalChecked", $(elm).prop("checked"));
            }
        }

        //检查是否有变更
        var isChanged = function(elm){
            elm = $(elm);
            var changed = false;
            if(elm.is("input,select,textarea,:radio,:checkbox")){
                changed = elm.data("__OriginalVal") != elm.val();

                if(!changed && elm.is(":radio,:checkbox")) {
                    changed = elm.data("__OriginalChecked") != elm.prop("checked");
                }
                return changed;
            } else {
                elm.find("input,select,textarea,:radio,:checkbox").each(function(){ 
                    if(!changed) changed = isChanged($(this));
                });
            }
            return changed;
        }
        
        //初始化
        if(options == undefined){
            this.find("input,select,textarea").each(function(){  reset($(this)); });
        }

        if(options == "reset"){
            this.each(function(){reset($(this));});
        }

        if(options == "isChanged"){
            return isChanged(this);
        }
    }
})(jQuery);